<template>
  <fieldset class="Radio">
    <legend v-if="label">{{ label }}</legend>

    <div class="Radio__Option" v-for="(value, label) in options" :key="label">
      <!--suppress HtmlFormInputWithoutLabel -->
      <input
        class="Radio__OptionInput"
        :id="uuid + '_' + label"
        :value="value"
        :name="uuid"
        :checked="value === modelValue"
        type="radio"
        @input="$emit('update:modelValue', value)"
      />
      <label :for="uuid + '_' + label" class="Radio__OptionLabel">{{
        noTranslate ? label : t(label)
      }}</label>
    </div>
    <Button
      v-if="isRestorable"
      :icon="Icons.restore"
      class="Radio__Restore Button--noBorder"
      :title="t('component.restore')"
      @click="$emit('update:modelValue', restoreValue)"
    />
  </fieldset>
</template>

<script lang="ts">
import { defineComponent, inject } from 'vue'
import { Icons } from '@/Icons'
import Dropdown from '@/components/controls/Dropdown.vue'

export default defineComponent({
  name: 'RadioButton',
  extends: Dropdown,

  setup() {
    return {
      Icons,
      t: inject('t', (str: unknown) => str),
    }
  },
})
</script>

<style lang="scss" scoped>
@use '../../style/variables' as v;

.Radio {
  position: relative;
  display: inline-flex;
  margin: v.$spacing;
  padding: v.$spacing;
  border: 1px solid dimgrey;
  border-radius: v.$borderRadius;
  outline: 0;

  &__Option {
    padding: v.$spacing/2;

    &Label {
      margin-left: v.$spacing/2;
      cursor: pointer;
    }

    &Input {
      cursor: pointer;
    }
  }
}
</style>
